Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding.cs	(revision 17461)
@@ -33,9 +33,9 @@
   [StorableType("D2FB1AF9-EF13-4ED2-B3E9-D5BE4E5772EA")]
   public abstract class ScheduleEncoding<TSchedule> : Encoding<TSchedule>, IScheduleEncoding
-  where TSchedule : class, ISchedule {
+  where TSchedule : class, IScheduleSolution {
     #region Encoding Parameters
     [Storable]
-    private IFixedValueParameter<ItemList<Job>> jobDataParameter;
-    public IFixedValueParameter<ItemList<Job>> JobDataParameter {
+    private IValueParameter<ItemList<Job>> jobDataParameter;
+    public IValueParameter<ItemList<Job>> JobDataParameter {
       get { return jobDataParameter; }
       set {
@@ -126,5 +126,4 @@
     }
 
-    protected ScheduleEncoding() : this("Schedule") { }
     protected ScheduleEncoding(string name) : this(name, Enumerable.Empty<Job>()) { }
     protected ScheduleEncoding(string name, IEnumerable<Job> jobData)
@@ -133,5 +132,5 @@
       int resources = jobData.SelectMany(j => j.Tasks).Select(t => t.ResourceNr).Distinct().Count();
 
-      jobDataParameter = new FixedValueParameter<ItemList<Job>>(Name + ".JobData", new ItemList<Job>(jobData));
+      jobDataParameter = new ValueParameter<ItemList<Job>>(Name + ".JobData", new ItemList<Job>(jobData));
       jobsParameter = new FixedValueParameter<IntValue>(Name + ".Jobs", new IntValue(jobs));
       resourcesParameter = new FixedValueParameter<IntValue>(Name + ".Resources", new IntValue(resources));
@@ -144,5 +143,5 @@
     }
 
-    public Schedule Decode(ISchedule schedule, ItemList<Job> jobData) {
+    public Schedule Decode(IScheduleSolution schedule, ItemList<Job> jobData) {
       return Decoder.DecodeSchedule(schedule, jobData);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Decoder/DirectScheduleDecoder.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Decoder/DirectScheduleDecoder.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Decoder/DirectScheduleDecoder.cs	(revision 17461)
@@ -27,5 +27,5 @@
   [Item("DirectScheduleDecoder", "An item used to convert a direct schedule into a generalized schedule.")]
   [StorableType("151C772B-6E6C-40D9-B171-F5626C676A5F")]
-  public class DirectScheduleDecoder : ScheduleDecoder<Schedule> {
+  public class DirectScheduleDecoder : ScheduleDecoder<Schedule>, IDirectScheduleOperator {
     [StorableConstructor]
     protected DirectScheduleDecoder(StorableConstructorFlag _) : base(_) { }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleEncoding.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleEncoding.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleEncoding.cs	(revision 17461)
@@ -31,4 +31,5 @@
 
 namespace HeuristicLab.Encodings.ScheduleEncoding {
+  [Item("Direct Schedule Encoding", "Encodes a solution by directly assigning start and end types to the tasks.")]
   [StorableType("BB1BD851-3E77-4357-942C-EAF5BE6760B4")]
   public sealed class DirectScheduleEncoding : ScheduleEncoding<Schedule> {
@@ -41,5 +42,5 @@
 
     public DirectScheduleEncoding()
-      : base() {
+      : base("Schedule") {
       SolutionCreator = new DirectScheduleRandomCreator();
       Decoder = new DirectScheduleDecoder();
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleRandomCreator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleRandomCreator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleRandomCreator.cs	(revision 17461)
@@ -54,5 +54,5 @@
 
 
-    public static Schedule Apply(PWREncoding pwr, ItemList<Job> jobData) {
+    public static Schedule Apply(PWR pwr, ItemList<Job> jobData) {
       var resultingSchedule = new Schedule(jobData[0].Tasks.Count);
       foreach (int jobNr in pwr.PermutationWithRepetition) {
@@ -70,5 +70,5 @@
     protected override Schedule CreateSolution() {
       var jobData = (ItemList<Job>)JobDataParameter.ActualValue.Clone();
-      var pwrEncoding = new PWREncoding(JobsParameter.ActualValue.Value, ResourcesParameter.ActualValue.Value,
+      var pwrEncoding = new PWR(JobsParameter.ActualValue.Value, ResourcesParameter.ActualValue.Value,
         RandomParameter.ActualValue);
       return Apply(pwrEncoding, jobData);
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Schedule.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Schedule.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Schedule.cs	(revision 17461)
@@ -31,5 +31,5 @@
   [Item("Schedule", "Represents the general solution for scheduling problems.")]
   [StorableType("EA6D14A3-7FA6-4B4B-B7F6-40B42657D398")]
-  public class Schedule : NamedItem, ISchedule {
+  public class Schedule : NamedItem, IScheduleSolution {
 
     #region Properties
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleManipulator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleManipulator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleManipulator.cs	(revision 17461)
@@ -32,6 +32,6 @@
   public abstract class ScheduleManipulator : InstrumentedOperator, IScheduleManipulator, IStochasticOperator {
 
-    public ILookupParameter<ISchedule> ScheduleParameter {
-      get { return (ILookupParameter<ISchedule>)Parameters["Schedule"]; }
+    public ILookupParameter<IScheduleSolution> ScheduleParameter {
+      get { return (ILookupParameter<IScheduleSolution>)Parameters["Schedule"]; }
     }
 
@@ -45,5 +45,5 @@
     public ScheduleManipulator()
       : base() {
-      Parameters.Add(new LookupParameter<ISchedule>("Schedule", "The scheduling solution to be manipulated."));
+      Parameters.Add(new LookupParameter<IScheduleSolution>("Schedule", "The scheduling solution to be manipulated."));
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Parameters/3.3/OptionalConstrainedValueParameter.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Parameters/3.3/OptionalConstrainedValueParameter.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Parameters/3.3/OptionalConstrainedValueParameter.cs	(revision 17461)
@@ -21,5 +21,7 @@
 
 using System;
+using System.Collections.Generic;
 using System.Drawing;
+using System.Linq;
 using HEAL.Attic;
 using HeuristicLab.Collections;
@@ -168,4 +170,9 @@
     #endregion
 
+    public void Populate(IEnumerable<IItem> items) {
+      ValidValues.Clear();
+      ValidValues.UnionWith(items.OfType<T>());
+    }
+
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj	(revision 17461)
@@ -116,5 +116,7 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="JobShopSchedulingProblemView.cs" />
+    <Compile Include="JobShopSchedulingProblemView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
     <Compile Include="JobShopSchedulingProblemView.Designer.cs">
       <DependentUpon>JobShopSchedulingProblemView.cs</DependentUpon>
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.cs	(revision 17461)
@@ -20,105 +20,105 @@
 #endregion
 
-//using System;
-//using System.Windows.Forms;
-//using HeuristicLab.Collections;
-//using HeuristicLab.Encodings.ScheduleEncoding;
-//using HeuristicLab.MainForm;
-//using HeuristicLab.Optimization.Views;
+using System;
+using System.Windows.Forms;
+using HeuristicLab.Collections;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.MainForm;
+using HeuristicLab.Optimization.Views;
 
-//namespace HeuristicLab.Problems.Scheduling.Views {
-//  [View("JobShop Scheduling Problem View")]
-//  [Content(typeof(JobShopSchedulingProblem), true)]
-//  public partial class JobShopSchedulingProblemView : ProblemView {
+namespace HeuristicLab.Problems.Scheduling.Views {
+  [View("JobShop Scheduling Problem View")]
+  [Content(typeof(JobShopSchedulingProblem), true)]
+  public partial class JobShopSchedulingProblemView : ProblemView {
 
-//    public new JobShopSchedulingProblem Content {
-//      get { return (JobShopSchedulingProblem)base.Content; }
-//      set { base.Content = value; }
-//    }
+    public new JobShopSchedulingProblem Content {
+      get { return (JobShopSchedulingProblem)base.Content; }
+      set { base.Content = value; }
+    }
 
-//    public JobShopSchedulingProblemView() {
-//      InitializeComponent();
-//      Controls.Remove(parameterCollectionView);
-//      parameterCollectionView.Dock = DockStyle.Fill;
-//      problemTabPage.Controls.Add(parameterCollectionView);
-//    }
+    public JobShopSchedulingProblemView() {
+      InitializeComponent();
+      Controls.Remove(parameterCollectionView);
+      parameterCollectionView.Dock = DockStyle.Fill;
+      problemTabPage.Controls.Add(parameterCollectionView);
+    }
 
-//    protected override void OnContentChanged() {
-//      base.OnContentChanged();
-//      FillGanttChart();
-//    }
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      FillGanttChart();
+    }
 
-//    protected override void DeregisterContentEvents() {
-//      Content.JobDataParameter.ValueChanged -= JobDataParameterOnValueChanged;
-//      Content.JobData.ItemsAdded -= JobsOnChanged;
-//      Content.JobData.ItemsRemoved -= JobsOnRemoved;
-//      Content.JobData.ItemsReplaced -= JobsOnChanged;
-//      Content.JobData.CollectionReset -= JobsOnChanged;
-//      foreach (var job in Content.JobData) {
-//        job.TasksChanged -= JobOnTasksChanged;
-//      }
-//      base.DeregisterContentEvents();
-//    }
-//    protected override void RegisterContentEvents() {
-//      base.RegisterContentEvents();
-//      Content.JobDataParameter.ValueChanged += JobDataParameterOnValueChanged;
-//      Content.JobData.ItemsAdded += JobsOnChanged;
-//      Content.JobData.ItemsRemoved += JobsOnRemoved;
-//      Content.JobData.ItemsReplaced += JobsOnChanged;
-//      Content.JobData.CollectionReset += JobsOnChanged;
-//      foreach (var job in Content.JobData) {
-//        job.TasksChanged += JobOnTasksChanged;
-//      }
-//    }
+    protected override void DeregisterContentEvents() {
+      Content.JobDataParameter.ValueChanged -= JobDataParameterOnValueChanged;
+      Content.JobData.ItemsAdded -= JobsOnChanged;
+      Content.JobData.ItemsRemoved -= JobsOnRemoved;
+      Content.JobData.ItemsReplaced -= JobsOnChanged;
+      Content.JobData.CollectionReset -= JobsOnChanged;
+      foreach (var job in Content.JobData) {
+        job.TasksChanged -= JobOnTasksChanged;
+      }
+      base.DeregisterContentEvents();
+    }
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.JobDataParameter.ValueChanged += JobDataParameterOnValueChanged;
+      Content.JobData.ItemsAdded += JobsOnChanged;
+      Content.JobData.ItemsRemoved += JobsOnRemoved;
+      Content.JobData.ItemsReplaced += JobsOnChanged;
+      Content.JobData.CollectionReset += JobsOnChanged;
+      foreach (var job in Content.JobData) {
+        job.TasksChanged += JobOnTasksChanged;
+      }
+    }
 
-//    private void JobsOnChanged(object sender, CollectionItemsChangedEventArgs<IndexedItem<Job>> e) {
-//      foreach (var job in e.OldItems)
-//        job.Value.TasksChanged -= JobOnTasksChanged;
-//      foreach (var job in e.Items)
-//        job.Value.TasksChanged += JobOnTasksChanged;
-//      FillGanttChart();
-//    }
+    private void JobsOnChanged(object sender, CollectionItemsChangedEventArgs<IndexedItem<Job>> e) {
+      foreach (var job in e.OldItems)
+        job.Value.TasksChanged -= JobOnTasksChanged;
+      foreach (var job in e.Items)
+        job.Value.TasksChanged += JobOnTasksChanged;
+      FillGanttChart();
+    }
 
-//    private void JobsOnRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<Job>> e) {
-//      foreach (var job in e.Items)
-//        job.Value.TasksChanged -= JobOnTasksChanged;
-//      FillGanttChart();
-//    }
+    private void JobsOnRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<Job>> e) {
+      foreach (var job in e.Items)
+        job.Value.TasksChanged -= JobOnTasksChanged;
+      FillGanttChart();
+    }
 
-//    private void JobDataParameterOnValueChanged(object sender, EventArgs e) {
-//      Content.JobData.ItemsAdded += JobsOnChanged;
-//      Content.JobData.ItemsRemoved += JobsOnRemoved;
-//      Content.JobData.ItemsReplaced += JobsOnChanged;
-//      Content.JobData.CollectionReset += JobsOnChanged;
-//      foreach (var job in Content.JobData) {
-//        job.TasksChanged += JobOnTasksChanged;
-//      }
-//      FillGanttChart();
-//    }
+    private void JobDataParameterOnValueChanged(object sender, EventArgs e) {
+      Content.JobData.ItemsAdded += JobsOnChanged;
+      Content.JobData.ItemsRemoved += JobsOnRemoved;
+      Content.JobData.ItemsReplaced += JobsOnChanged;
+      Content.JobData.CollectionReset += JobsOnChanged;
+      foreach (var job in Content.JobData) {
+        job.TasksChanged += JobOnTasksChanged;
+      }
+      FillGanttChart();
+    }
 
-//    private void JobOnTasksChanged(object sender, EventArgs e) {
-//      FillGanttChart();
-//    }
+    private void JobOnTasksChanged(object sender, EventArgs e) {
+      FillGanttChart();
+    }
 
-//    private void FillGanttChart() {
-//      ganttChart.Reset();
-//      if (Content == null) return;
-//      int jobCount = 0;
-//      foreach (var j in Content.JobData) {
-//        double lastEndTime = 0;
-//        foreach (var t in Content.JobData[jobCount].Tasks) {
-//          int categoryNr = t.JobNr;
-//          string categoryName = "Job" + categoryNr;
-//          ganttChart.AddData(categoryName,
-//            categoryNr,
-//            t.TaskNr,
-//            lastEndTime + 1,
-//            lastEndTime + t.Duration,
-//            "Job" + t.JobNr + " - " + "Task#" + t.TaskNr);
-//          lastEndTime += t.Duration;
-//        }
-//        jobCount++;
-//      }
-//    }
-//  }
-//}
+    private void FillGanttChart() {
+      ganttChart.Reset();
+      if (Content == null) return;
+      int jobCount = 0;
+      foreach (var j in Content.JobData) {
+        double lastEndTime = 0;
+        foreach (var t in Content.JobData[jobCount].Tasks) {
+          int categoryNr = t.JobNr;
+          string categoryName = "Job" + categoryNr;
+          ganttChart.AddData(categoryName,
+            categoryNr,
+            t.TaskNr,
+            lastEndTime + 1,
+            lastEndTime + t.Duration,
+            "Job" + t.JobNr + " - " + "Task#" + t.TaskNr);
+          lastEndTime += t.Duration;
+        }
+        jobCount++;
+      }
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj	(revision 17461)
@@ -112,18 +112,9 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Analyzers\BestSchedulingSolutionAnalyzer.cs" />
-    <Compile Include="Analyzers\SchedulingAnalyzer.cs" />
-    <Compile Include="Evaluators\MeanTardinessEvaluator.cs" />
-    <Compile Include="Evaluators\MakespanEvaluator.cs" />
-    <Compile Include="Evaluators\ScheduleEvaluator.cs" />
-    <Compile Include="Interfaces\IJSSPOperator.cs" />
-    <Compile Include="Interfaces\IScheduleEvaluator.cs" />
-    <Compile Include="Interfaces\ISchedulingEvaluator.cs" />
-    <Compile Include="JobShopSchedulingProblem new.cs" />
+    <Compile Include="Objectives\MeanTardiness.cs" />
+    <Compile Include="Objectives\Makespan.cs" />
     <Compile Include="JobShopSchedulingProblem.cs" />
-    <Compile Include="Evaluators\SchedulingEvaluator.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="SchedulingProblem.cs" />
   </ItemGroup>
   <ItemGroup>
